searchNodes=[{"doc":"This is an Elixir library for interacting with the Zendesk platform. It handles streaming paginated lists of tickets and users, and allows you to interact with the API with only a thin layer of Elixiry abstraction.","ref":"Zendesk.html","title":"Zendesk","type":"module"},{"doc":"Send a given Zendesk.Client.Operation to the API endpoint. This is the general entry point for all requests.","ref":"Zendesk.html#request/1","title":"Zendesk.request/1","type":"function"},{"doc":"Send a given Zendesk.Client.Operation to the API endpoint, raising if there's any error.","ref":"Zendesk.html#request!/1","title":"Zendesk.request!/1","type":"function"},{"doc":"Make a request, producing a Stream for paginating results. Send a given Zendesk.Client.Operation to the API endpoint with the expectation that the Zendesk.Client.Operation will produce a paginated result. Any errors will raise an exception.","ref":"Zendesk.html#stream!/1","title":"Zendesk.stream!/1","type":"function"},{"doc":"Make requests to the API. The requests are made using Zendesk.Client.Operation s.","ref":"Zendesk.Client.html","title":"Zendesk.Client","type":"module"},{"doc":"Make a DELETE request to the API at the given URL.","ref":"Zendesk.Client.html#delete/2","title":"Zendesk.Client.delete/2","type":"function"},{"doc":"Make a GET request to the API at the given URL.","ref":"Zendesk.Client.html#get/3","title":"Zendesk.Client.get/3","type":"function"},{"doc":"Make a POST request to the API at the given URL.","ref":"Zendesk.Client.html#post/3","title":"Zendesk.Client.post/3","type":"function"},{"doc":"Make a PUT request to the API at the given URL.","ref":"Zendesk.Client.html#put/3","title":"Zendesk.Client.put/3","type":"function"},{"doc":"Call the API with the given Zendesk.Client.Operation .","ref":"Zendesk.Client.html#request/1","title":"Zendesk.Client.request/1","type":"function"},{"doc":"Call the API with the given Zendesk.Client.Operation . This function throws an error if there was any issue calling the API.","ref":"Zendesk.Client.html#request!/1","title":"Zendesk.Client.request!/1","type":"function"},{"doc":"A description of a specific API call.","ref":"Zendesk.Client.Operation.html","title":"Zendesk.Client.Operation","type":"module"},{"doc":"Add a page size to the Operation to enforce a cursor style pagination of the result.","ref":"Zendesk.Client.Operation.html#with_page_size/2","title":"Zendesk.Client.Operation.with_page_size/2","type":"function"},{"doc":"","ref":"Zendesk.Client.Operation.html#t:operation_type/0","title":"Zendesk.Client.Operation.operation_type/0","type":"type"},{"doc":"","ref":"Zendesk.Client.Operation.html#t:t/0","title":"Zendesk.Client.Operation.t/0","type":"type"},{"doc":"This module contains functions used in parsing the results of API calls. In this context, &quot;parsing&quot; occurs after JSON responses have been decoded into a Map with atom keys.","ref":"Zendesk.Client.Parser.html","title":"Zendesk.Client.Parser","type":"module"},{"doc":"Provide a default parser in case an Zendesk.Client.Operation doesn't specify one. This just returns the body of the response. This is useful for downloading files, for instance, where there's no transformation that should be done on the result.","ref":"Zendesk.Client.Parser.html#default_parse/1","title":"Zendesk.Client.Parser.default_parse/1","type":"function"},{"doc":"A result from a parsed API call that is streamable (i.e., a pagninated list).","ref":"Zendesk.Client.Parser.html#t:parsed_list_result/0","title":"Zendesk.Client.Parser.parsed_list_result/0","type":"type"},{"doc":"Either a single or list result.","ref":"Zendesk.Client.Parser.html#t:parsed_result/0","title":"Zendesk.Client.Parser.parsed_result/0","type":"type"},{"doc":"A single result from a parsed API call.","ref":"Zendesk.Client.Parser.html#t:parsed_single_result/0","title":"Zendesk.Client.Parser.parsed_single_result/0","type":"type"},{"doc":"","ref":"Zendesk.Client.Parser.html#t:parser_func/0","title":"Zendesk.Client.Parser.parser_func/0","type":"type"},{"doc":"This module is used to represent the result of an API call. It is passed to the parser specified in a given Zendesk.Client.Operation and the result is what's returned from an Zendesk.Client.request/1 .","ref":"Zendesk.Client.Result.html","title":"Zendesk.Client.Result","type":"module"},{"doc":"Convert the raw results of an API call and turn them into a Zendesk.Client.Result .","ref":"Zendesk.Client.Result.html#from_encoded/3","title":"Zendesk.Client.Result.from_encoded/3","type":"function"},{"doc":"Convert the Zendesk.Client.Result of an API call and turn it into a Zendesk.Client.Streamable . This is used in cases where we expect the result to contain pagination.","ref":"Zendesk.Client.Result.html#to_streamable/1","title":"Zendesk.Client.Result.to_streamable/1","type":"function"},{"doc":"","ref":"Zendesk.Client.Result.html#t:t/0","title":"Zendesk.Client.Result.t/0","type":"type"},{"doc":"Handle streamable (i.e., paginated) responses from the API.","ref":"Zendesk.Client.Streamable.html","title":"Zendesk.Client.Streamable","type":"module"},{"doc":"Produce a Stream for a given Zendesk.Client.Operation . For instance: # get 400 tickets Zendesk.Ticket . list ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 400 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( )","ref":"Zendesk.Client.Streamable.html#stream!/1","title":"Zendesk.Client.Streamable.stream!/1","type":"function"},{"doc":"","ref":"Zendesk.Client.Streamable.html#t:t/0","title":"Zendesk.Client.Streamable.t/0","type":"type"},{"doc":"","ref":"Zendesk.Comment.html","title":"Zendesk.Comment","type":"module"},{"doc":"Create a Zendesk.Comment . If passed to Zendesk.request!/1 it will return the entity which the comment was added to (e.g., a Zendesk.Ticket ).","ref":"Zendesk.Comment.html#create_for/2","title":"Zendesk.Comment.create_for/2","type":"function"},{"doc":"Get a list of Zendesk.Comment s. If passed to Zendesk.request!/1 it will return only the first results from the list. You can create a Stream to paginate over all results by calling Zendesk.stream!/1 . For instance: # get 400 comments for a ticket ticket |&gt; Zendesk.Comment . list_for ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 400 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( )","ref":"Zendesk.Comment.html#list_for/1","title":"Zendesk.Comment.list_for/1","type":"function"},{"doc":"","ref":"Zendesk.Comment.html#t:t/0","title":"Zendesk.Comment.t/0","type":"type"},{"doc":"","ref":"Zendesk.Macro.html","title":"Zendesk.Macro","type":"module"},{"doc":"Get a list of Zendesk.Macro s. If passed to Zendesk.request!/1 it will return only the first results from the list. You can create a Stream to paginate over all results by calling Zendesk.stream!/1 . For instance: # get 400 macros Zendesk.Macro . list ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 400 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( )","ref":"Zendesk.Macro.html#list/0","title":"Zendesk.Macro.list/0","type":"function"},{"doc":"Get a specific Zendesk.Macro .","ref":"Zendesk.Macro.html#show/1","title":"Zendesk.Macro.show/1","type":"function"},{"doc":"Returns the changes the macro would make to a ticket. It doesn't actually change a ticket.","ref":"Zendesk.Macro.html#ticket_changes/1","title":"Zendesk.Macro.ticket_changes/1","type":"function"},{"doc":"","ref":"Zendesk.Macro.html#t:t/0","title":"Zendesk.Macro.t/0","type":"type"},{"doc":"","ref":"Zendesk.Ticket.html","title":"Zendesk.Ticket","type":"module"},{"doc":"Returns the full ticket object as it would be after applying the macro to the ticket. It doesn't actually change the ticket.","ref":"Zendesk.Ticket.html#after_changes/2","title":"Zendesk.Ticket.after_changes/2","type":"function"},{"doc":"Create a Ticket with the given parameters.","ref":"Zendesk.Ticket.html#create/1","title":"Zendesk.Ticket.create/1","type":"function"},{"doc":"Create a Comment for the given Ticket .","ref":"Zendesk.Ticket.html#create_comment/2","title":"Zendesk.Ticket.create_comment/2","type":"function"},{"doc":"Get Comment s for the given Ticket .","ref":"Zendesk.Ticket.html#get_comments/1","title":"Zendesk.Ticket.get_comments/1","type":"function"},{"doc":"Get a list of Zendesk.Ticket s. If passed to Zendesk.request!/1 it will return only the first results from the list. You can create a Stream to paginate over all results by calling Zendesk.stream!/1 . For instance: # get 400 tickets Zendesk.Ticket . list ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 400 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( )","ref":"Zendesk.Ticket.html#list/0","title":"Zendesk.Ticket.list/0","type":"function"},{"doc":"Get a specific Zendesk.Ticket .","ref":"Zendesk.Ticket.html#show/1","title":"Zendesk.Ticket.show/1","type":"function"},{"doc":"Update a Ticket with the given parameters.","ref":"Zendesk.Ticket.html#update/2","title":"Zendesk.Ticket.update/2","type":"function"},{"doc":"","ref":"Zendesk.Ticket.html#t:t/0","title":"Zendesk.Ticket.t/0","type":"type"},{"doc":"","ref":"Zendesk.User.html","title":"Zendesk.User","type":"module"},{"doc":"Delete a specific Zendesk.User .","ref":"Zendesk.User.html#delete/1","title":"Zendesk.User.delete/1","type":"function"},{"doc":"Get information for the specific Zendesk.User whose credentials are being used.","ref":"Zendesk.User.html#get_requestor/0","title":"Zendesk.User.get_requestor/0","type":"function"},{"doc":"Get a list of Zendesk.User s. If passed to Zendesk.request!/1 it will return only the first results from the list. You can create a Stream to paginate over all results by calling Zendesk.stream!/1 . For instance: # get 400 users Zendesk.User . list ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 400 ) |&gt; Enum . to_list ( ) |&gt; IO . inspect ( )","ref":"Zendesk.User.html#list/1","title":"Zendesk.User.list/1","type":"function"},{"doc":"Permanently delete a specific Zendesk.User . Note that Zendesk.User.delete/1 must be called first for this user.","ref":"Zendesk.User.html#permanently_delete/1","title":"Zendesk.User.permanently_delete/1","type":"function"},{"doc":"","ref":"Zendesk.User.html#search/1","title":"Zendesk.User.search/1","type":"function"},{"doc":"Get a specific Zendesk.User .","ref":"Zendesk.User.html#show/1","title":"Zendesk.User.show/1","type":"function"},{"doc":"","ref":"Zendesk.User.html#t:t/0","title":"Zendesk.User.t/0","type":"type"},{"doc":"This is an Elixir library for interacting with the Zendesk platform.","ref":"readme.html","title":"Zendesk Elixir Library","type":"extras"},{"doc":"The package can be installed by adding zendesk to your list of dependencies in mix.exs : def deps do [ { :zendesk , &quot;~&gt; 0.1&quot; } ] end Check Hex to make sure you're using an up-to-date version number.","ref":"readme.html#installation","title":"Zendesk Elixir Library - Installation","type":"extras"},{"doc":"You'll need a Zendesk user email and token to access the API (based on security recommendations from Zendesk, password authentication isn't supported). config :zendesk , token : &quot;asdf123&quot; , email : &quot;someuser@example.com&quot; , subdomain : &quot;mysubdomain&quot; Then, you can build and send requests. # To stream all tickets, paginating behind the scenes: Zendesk.Ticket . list ( ) |&gt; Zendesk . stream! ( ) |&gt; Stream . take ( 100 ) |&gt; Enum . to_list ( ) # To get a specific ticket by ID: ticket = Zendesk.Ticket . show ( 123 ) |&gt; Zendesk . request! ( ) # To get a specific user by ID: user = Zendesk.User . show ( 123 ) |&gt; Zendesk . request! ( ) See the list of modules for a list of the other types (Users, Tickets, Macros, etc) available.","ref":"readme.html#usage","title":"Zendesk Elixir Library - Usage","type":"extras"},{"doc":"To run tests: $ mix test","ref":"readme.html#running-tests","title":"Zendesk Elixir Library - Running Tests","type":"extras"},{"doc":"Please report all issues on github .","ref":"readme.html#reporting-issues","title":"Zendesk Elixir Library - Reporting Issues","type":"extras"}]